/*
 * 29/03/2004
 *
 * label.cpp
 * Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "label.h"

// ============
// Constructeur
// ============
CLabel::CLabel(int i, char *s, ...) : CWidget(i) {
	m_label = new char[64];
	va_list ap;
	
	if(s==NULL)
		return;

	va_start(ap, s);
	vsprintf(m_label, s, ap);
	va_end(ap);
}

// ============
// Constructeur
// ============
CLabel::CLabel(char *s, ...) : CWidget(0) {
	m_label = new char[64];
	va_list ap;
	
	if(s==NULL)
		return;

	va_start(ap, s);
	vsprintf(m_label, s, ap);
	va_end(ap);
}

// ===========
// Destructeur
// ===========
CLabel::~CLabel() {
	delete m_label;
}

void CLabel::SetLabel(char *s, ...) {
	va_list ap;
	
	if(s==NULL)
		return;

	va_start(ap, s);
	vsprintf(m_label, s, ap);
	va_end(ap);

}

void CLabel::Draw() {

	if (m_visible) {
	glPushMatrix();
	glTranslatef(x, y, 0.0f);

	if (m_enable) glColor3f(0.8, 0.8, 0.8); else glColor3f(0.3f, 0.3f, 0.3f);
	drawText(3, 4, "%s", m_label);
	
	glPopMatrix();
	}
}

