/*
 * 29/03/2004
 *
 * radiobutton.h
 * Classe RadioButton
 *
 * Author: Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _RADIOBUTTON_H
#define _RADIOBUTTON_H

#include "widget.h"
#include "radiogroup.h"

class CRadioButton : public CWidget
{
public:

	// ============
	// Constructeur
	// ============
	CRadioButton(int i, char *label, CRadioGroup *radioGroup);

	// ===========
	// Destructeur
	// ===========
	~CRadioButton();

	void Mouse(int button, int state, int mx, int my);
	void MouseMotion(int mx, int my);
	void MousePassiveMotion(int mx, int my);

	void Draw();

	bool IsSelected();

	void SetSelected(bool select);

private:

	char *m_label;
	
	CRadioGroup *m_radioGroup;
};

#endif



