/*
 * 29/03/2004
 *
 * transferfunction.h
 * Classe TransferFunction
 *
 * Author: Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _TRANSFERFUNCTION_H
#define _TRANSFERFUNCTION_H

#ifdef _WIN32
#include <windows.h>
#endif
#include <GL/gl.h>
#include "widget.h"
#include "../imaging/image3D.h"

class CTransferFunction : public CWidget
{
public:

	// ============
	// Constructeur
	// ============
	CTransferFunction(int i, CImage3D *img);

	// ===========
	// Destructeur
	// ===========
	~CTransferFunction();

	void Mouse(int button, int state, int mx, int my);
	void MouseMotion(int button, int px, int py, int nx, int ny);
	void MousePassiveMotion(int mx, int my);

	void Draw();

	GLubyte tf[4*256];

	int selected;

	void Maj();

	void Init(CImage3D *img);

private:
	int cursor1;
	int cursor2;
	
	int RetrieveCursorID(int mx, int my);

	int *histo;
	long nbVoxels;

	#define NB_CP 6
	int cp[NB_CP][2];

	int m_cpmouseon;

	// Identifiant des listes d'affichage
	GLuint m_displayList[1];
};

#endif

