/*
 * 29/03/2004
 *
 * mygui.cpp
 * Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "mygui.h"

// ============
// Constructeur
// ============
CMyGui::CMyGui(int i, CImage3D *img) : CGui(i) {
	tf = new CTransferFunction(TRANSFERFUNCTION, img);
	menu = new CButton(BUTTON_MENU, "Menu");
	infos = new CButton(BUTTON_INFOS, "Infos");
	exit = new CButton(BUTTON_EXIT, "Exit");

	tfapply = new CButton(BUTTON_TFAPPLY, "Apply TF");
	tfinit = new CButton(BUTTON_TFINIT, "Init TF");

	usetf = new CCheckbox(CHECKBOX_USETF, "Use TF");
	
	filter = new CCheckbox(CHECKBOX_FILTER, "Filter GL_LINEAR");

	blending = new CLabel("Blending operators:");
	blendingGroup = new CRadioGroup(4);
	norm = new CRadioButton(RADIO_NORM,"norm",blendingGroup);
	over = new CRadioButton(RADIO_OVER,"over",blendingGroup);
	attenuate = new CRadioButton(RADIO_ATT,"att",blendingGroup);
	mip = new CRadioButton(RADIO_MIP,"mip",blendingGroup);
	blendingGroup->Add(over);
	blendingGroup->Add(norm);
	blendingGroup->Add(attenuate);
	blendingGroup->Add(mip);

	fps = new CLabel("10 fps");
	size = new CLabel("Size:");	

	dplus = new CButton(BUTTON_DPLUS, "+");
	dminus = new CButton(BUTTON_DMINUS, "-");
	density = new CLabel("Density:");

	iplus = new CButton(BUTTON_IPLUS, "+");
	iminus = new CButton(BUTTON_IMINUS, "-");
	intensity = new CLabel("Intensity:");

	splus = new CButton(BUTTON_SPLUS, "+");
	sminus = new CButton(BUTTON_SMINUS, "-");
	slices = new CLabel("Slices:");

	title = new CLabel("%s v%s %s", APP_NAME, RELEASE, BUILD);
	underline = new CLabel("---------------------");
	projet = new CLabel("Projet 150h Informatique Graphique");
	dess = new CLabel("DESS Informatique (ULP STRASBOURG)");
	author = new CLabel("Thierry Vouriot (yeri@fr.st)");
	web = new CLabel("http://www.yeri.fr.st");

	if (GL_EXT_paletted_texture_supported) extpalettedtexture = new CLabel("GL_EXT_paletted_texture: YES");
	else extpalettedtexture = new CLabel("GL_EXT_paletted_texture: NO");
	if (GL_EXT_blend_color_supported) extblendcolor = new CLabel("GL_EXT_blend_color: YES");
	else extblendcolor = new CLabel("GL_EXT_blend_color: NO");
	if (GL_EXT_blend_minmax_supported) extblendminmax = new CLabel("GL_EXT_minmax_color: YES");
	else extblendminmax = new CLabel("GL_EXT_minmax_color: NO");
	
	show = 1;
	SetPosition(0, 0);
}

// ===========
// Destructeur
	// ===========
CMyGui::~CMyGui() {

}

void CMyGui::Draw(int xsize, int ysize) {
	
	if (m_visible) {
	BeginDraw(xsize,ysize);
	
	tf->Draw();
	menu->Draw();
	infos->Draw();
	exit->Draw();
	tfapply->Draw();
	tfinit->Draw();
	fps->Draw();
	usetf->Draw();
	filter->Draw();
	
	blending->Draw();
	over->Draw();
	attenuate->Draw();
	mip->Draw();
	norm->Draw();

	size->Draw();
	density->Draw();

	dplus->Draw();
	dminus->Draw();

	slices->Draw();
	splus->Draw();
	sminus->Draw();

	intensity->Draw();
	iplus->Draw();
	iminus->Draw();
	
	title->Draw();
	underline->Draw();
	projet->Draw();
	dess->Draw();
	author->Draw();
	web->Draw();

	extpalettedtexture->Draw();
	extblendcolor->Draw();
	extblendminmax->Draw();
	
	EndDraw();
	}
}

void CMyGui::Mouse(int button, int state, int mx, int my) {
	if (m_visible) {
	tf->Mouse(button, state, mx, my);
	menu->Mouse(button, state, mx, my);
	infos->Mouse(button, state, mx, my);
	exit->Mouse(button, state, mx, my);

	tfapply->Mouse(button, state, mx, my);
	tfinit->Mouse(button, state, mx, my);

	usetf->Mouse(button, state, mx, my);
	filter->Mouse(button, state, mx, my);
	over->Mouse(button, state, mx, my);
	attenuate->Mouse(button, state, mx, my);
	mip->Mouse(button, state, mx, my);
	norm->Mouse(button, state, mx, my);

	dplus->Mouse(button, state, mx, my);
	dminus->Mouse(button, state, mx, my);

	splus->Mouse(button, state, mx, my);
	sminus->Mouse(button, state, mx, my);

	iplus->Mouse(button, state, mx, my);
	iminus->Mouse(button, state, mx, my);
	}
}

void CMyGui::MouseMotion(int button, int px, int py, int nx, int ny) {
	if (m_visible) {
	tf->MouseMotion(button, px, py, nx, ny);
	}
}

void CMyGui::MousePassiveMotion(int mx, int my) {
	if (m_visible) {
	tf->MousePassiveMotion(mx, my);
	menu->MousePassiveMotion(mx, my);
	infos->MousePassiveMotion(mx, my);
	exit->MousePassiveMotion(mx, my);

	tfapply->MousePassiveMotion(mx, my);
	tfinit->MousePassiveMotion(mx, my);

	usetf->MousePassiveMotion(mx, my);
	filter->MousePassiveMotion(mx, my);
	over->MousePassiveMotion(mx, my);
	attenuate->MousePassiveMotion(mx, my);
	mip->MousePassiveMotion(mx, my);
	norm->MousePassiveMotion(mx, my);

	dplus->MousePassiveMotion(mx, my);
	dminus->MousePassiveMotion(mx, my);

	splus->MousePassiveMotion(mx, my);
	sminus->MousePassiveMotion(mx, my);

	iplus->MousePassiveMotion(mx, my);
	iminus->MousePassiveMotion(mx, my);
	}
}

void CMyGui::OnClick(void (*func)(int i)) {
	
	mouseClickFunc = func;
	tf->OnClick(func);
	menu->OnClick(func);
	infos->OnClick(func);
	exit->OnClick(func);

	tfapply->OnClick(func);
	tfinit->OnClick(func);

	usetf->OnClick(func);
	filter->OnClick(func);
	over->OnClick(func);
	attenuate->OnClick(func);
	mip->OnClick(func);
	norm->OnClick(func);

	dplus->OnClick(func);
	dminus->OnClick(func);

	splus->OnClick(func);
	sminus->OnClick(func);

	iplus->OnClick(func);
	iminus->OnClick(func);
	

}

void CMyGui::OnMotion(void (*func)(int i, int x, int y)) {
	if (m_visible) {
	mouseMotionFunc = func;
	tf->OnMotion(func);
	}
}

void CMyGui::SetPosition(int px, int py) {

	x = px; y = py;

	tf->x = x+10; tf->y = y+2;
	
	tfapply->x = x+85; tfapply->y = y+150;
	tfinit->x = x+10; tfinit->y = y+150;

	usetf->x = x+10; usetf->y = y+180;

	norm->x = x+10; norm->y = y+210;
	over->x = x+65; over->y = y+210;
	attenuate->x = x+120; attenuate->y = y+210;
	mip->x = x+170; mip->y = y+210;
	blending->x = x+10; blending->y = y+230;
	filter->x = x+10; filter->y = y+260;
	

	slices->x = x+10; slices->y = y+290;
	splus->x = x+140; splus->y = y+290;
	sminus->x = x+160; sminus->y = y+290;

	intensity->x = x+10; intensity->y = y+320;
	iplus->x = x+140; iplus->y = y+320;
	iminus->x = x+160; iminus->y = y+320;

	density->x = x+10; density->y = y+350;
	dplus->x = x+140; dplus->y = y+350;
	dminus->x = x+160; dminus->y = y+350;
	
	size->x = x+10; size->y = y+380;


	title->x = x+10; title->y = y+380;
	underline->x = x+10; underline->y = y+370;
	projet->x = x+10; projet->y = y+350;
	dess->x = x+10; dess->y = y+330;
	author->x = x+10; author->y = y+310;
	web->x = x+10; web->y = y+290;

	extpalettedtexture->x = x+10; extpalettedtexture->y = y+10;
	extblendcolor->x = x+10; extblendcolor->y = y+30;
	extblendminmax->x = x+10; extblendminmax->y = y+50;
}

void CMyGui::SetShow(int i) {

	show = i;
	
	menu->SetVisible(true);
	infos->SetVisible(true);
	exit->SetVisible(true);
	fps->SetVisible(true);

	if (show == MENU) {
		menu->x = x+10; menu->y = y+410;
		infos->x = x+60; infos->y = y+410;
		exit->x = x+118; exit->y = y+410;
		fps->x = x; fps->y = y+435;

		
		tf->SetVisible(true);
		tfapply->SetVisible(true);
		tfinit->SetVisible(true);
		usetf->SetVisible(true);
		filter->SetVisible(true);
		over->SetVisible(true);
		attenuate->SetVisible(true);
		norm->SetVisible(true);
		mip->SetVisible(true);
		blending->SetVisible(true);
		size->SetVisible(true);
		density->SetVisible(true);
		dplus->SetVisible(true);
		dminus->SetVisible(true);
		slices->SetVisible(true);
		splus->SetVisible(true);
		sminus->SetVisible(true);
		intensity->SetVisible(true);
		iplus->SetVisible(true);
		iminus->SetVisible(true);

		title->SetVisible(false);
		underline->SetVisible(false);
		projet->SetVisible(false);
		dess->SetVisible(false);
		author->SetVisible(false);
		web->SetVisible(false);
		extpalettedtexture->SetVisible(false);
		extblendcolor->SetVisible(false);
		extblendminmax->SetVisible(false);


	}
	else if (show == INFOS) {
		menu->x = x+10; menu->y = y+410;
		infos->x = x+60; infos->y = y+410;
		exit->x = x+118; exit->y = y+410;
		fps->x = x; fps->y = y+435;

		tf->SetVisible(false);
		tfapply->SetVisible(false);
		tfinit->SetVisible(false);
		usetf->SetVisible(false);
		filter->SetVisible(false);
		norm->SetVisible(false);
		over->SetVisible(false);
		attenuate->SetVisible(false);
		mip->SetVisible(false);
		blending->SetVisible(false);
		size->SetVisible(false);
		density->SetVisible(false);
		dplus->SetVisible(false);
		dminus->SetVisible(false);
		slices->SetVisible(false);
		splus->SetVisible(false);
		sminus->SetVisible(false);
		intensity->SetVisible(false);
		iplus->SetVisible(false);
		iminus->SetVisible(false);

		title->SetVisible(true);
		underline->SetVisible(true);
		projet->SetVisible(true);
		dess->SetVisible(true);
		author->SetVisible(true);
		web->SetVisible(true);
		extpalettedtexture->SetVisible(true);
		extblendcolor->SetVisible(true);
		extblendminmax->SetVisible(true);

	}
	else {
		menu->x = x+10; menu->y = y+10;
		infos->x = x+60; infos->y = y+10;
		exit->x = x+118; exit->y = y+10;
		fps->x = x; fps->y = y+35;

		tf->SetVisible(false);
		tfapply->SetVisible(false);
		tfinit->SetVisible(false);
		usetf->SetVisible(false);
		filter->SetVisible(false);
		norm->SetVisible(false);
		over->SetVisible(false);
		attenuate->SetVisible(false);
		mip->SetVisible(false);
		blending->SetVisible(false);
		size->SetVisible(false);
		density->SetVisible(false);
		dplus->SetVisible(false);
		dminus->SetVisible(false);
		slices->SetVisible(false);
		splus->SetVisible(false);
		sminus->SetVisible(false);
		intensity->SetVisible(false);
		iplus->SetVisible(false);
		iminus->SetVisible(false);

		title->SetVisible(false);
		underline->SetVisible(false);
		projet->SetVisible(false);
		dess->SetVisible(false);
		author->SetVisible(false);
		web->SetVisible(false);
		extpalettedtexture->SetVisible(false);
		extblendcolor->SetVisible(false);
		extblendminmax->SetVisible(false);


	}

}


