/*
 * 29/03/2004
 *
 * mygui.h
 * Interface graphique de Visuvo
 *
 * Author: Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _MYGUI_H
#define _MYGUI_H

#define BUTTON_TFAPPLY 1
#define BUTTON_MENU 2
#define BUTTON_DPLUS 3
#define BUTTON_DMINUS 4
#define BUTTON_SPLUS 5
#define BUTTON_SMINUS 6
#define BUTTON_IPLUS 7
#define BUTTON_IMINUS 8
#define BUTTON_INFOS 9
#define BUTTON_EXIT 91
#define BUTTON_TFINIT 92

#define CHECKBOX_USETF 10
#define CHECKBOX_FILTER 11

#define TRANSFERFUNCTION 22

#define RADIO_OVER 30
#define RADIO_ATT 31
#define RADIO_MIP 32
#define RADIO_NORM 33

#define MENU 1
#define INFOS 2
#define NO 0

#include "globals.h"
#include "gui/gui.h"
#include "gui/transferfunction.h"
#include "gui/button.h"
#include "gui/label.h"
#include "gui/checkbox.h"
#include "gui/radiobutton.h"
#include "gui/radiogroup.h"
#include "imaging/image3D.h"
#include "ogl/glextensions.h"

class CMyGui : public CGui
{
public:

	// ============
	// Constructeur
	// ============
	CMyGui(int i, CImage3D *img);

	// ===========
	// Destructeur
	// ===========
	~CMyGui();

	void Draw(int xsize, int ysize);

	void Mouse(int button, int state, int mx, int my);
	void MouseMotion(int button, int px, int py, int nx, int ny);
	void MousePassiveMotion(int mx, int my);

	void OnClick(void (*func)(int i));
	void OnMotion(void (*func)(int i, int x, int y));

	void SetPosition(int x, int y);

	void SetShow(int i);

	CTransferFunction *tf;
	CButton *menu;
	CButton *infos;
	CButton *exit;

	CButton *tfinit;
	CButton *tfapply;

	CButton *dplus;
	CButton *dminus;
	CLabel *density;

	CButton *splus;
	CButton *sminus;
	CLabel *slices;

	CButton *iplus;
	CButton *iminus;
	CLabel *intensity;

	CLabel *size;
	CLabel *fps;
	
	CCheckbox *usetf;
	CCheckbox *filter;

	CLabel *blending;
	CRadioGroup *blendingGroup;
	CRadioButton *norm;
	CRadioButton *over;
	CRadioButton *attenuate;
	CRadioButton *mip;

	CLabel *title;
	CLabel *underline;
	CLabel *projet;
	CLabel *dess;
	CLabel *author;
	CLabel *web;

	CLabel *extpalettedtexture;
	CLabel *extblendcolor;
	CLabel *extblendminmax;

	int show;
};

#endif

