/*
 * 29/03/2004
 *
 * glextensions.cpp
 * Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */ 

#include "glextensions.h"


bool GL_EXT_texture3D_supported					= false;
bool GL_EXT_paletted_texture_supported			= false;
bool GL_EXT_blend_color_supported				= false;
bool GL_EXT_blend_minmax_supported				= false;


// GL_EXT_texture3D
PFNGLTEXIMAGE3DEXTPROC glTexImage3DEXT = NULL;



PFNGLCOLORTABLEEXTPROC					glColorTableEXT					= NULL;
PFNGLGETCOLORTABLEEXTPROC				glGetColorTableEXT				= NULL;
PFNGLGETCOLORTABLEPARAMETERIVEXTPROC	glGetColorTableParameterivEXT	= NULL;
PFNGLGETCOLORTABLEPARAMETERFVEXTPROC	glGetColorTableParameterfvEXT	= NULL;


PFNGLBLENDCOLOREXTPROC glBlendColorEXT = NULL;

PFNGLBLENDEQUATIONEXTPROC glBlendEquationEXT = NULL;


/* ------------------------------------------------------------------ */

bool findExtension(char *extensions, char *extension){
	if (extensions){
		char *str = extensions;
		int len = strlen(extension);
		
		while ((str = strstr(str, extension)) != NULL){
			str += len;
			if (*str == ' ' || *str == '\0') return true;
		}
	}
	return false;
}

#include <stdio.h>
void initExtensions(void){
	
	char *extensions = (char *) glGetString(GL_EXTENSIONS);
	printf("%s\n", extensions);
	
	if (GL_EXT_texture3D_supported = isExtensionSupported("GL_EXT_texture3D")){
		glTexImage3DEXT = (PFNGLTEXIMAGE3DEXTPROC) wglxGetProcAddress("glTexImage3DEXT");
	}

	if (GL_EXT_paletted_texture_supported = isExtensionSupported("GL_EXT_paletted_texture")){
		glColorTableEXT = (PFNGLCOLORTABLEEXTPROC) wglxGetProcAddress("glColorTableEXT");
		glGetColorTableEXT = (PFNGLGETCOLORTABLEEXTPROC) wglxGetProcAddress("glGetColorTableEXT");
		glGetColorTableParameterivEXT = (PFNGLGETCOLORTABLEPARAMETERIVEXTPROC) wglxGetProcAddress("glGetColorTableParameterivEXT");
		glGetColorTableParameterfvEXT = (PFNGLGETCOLORTABLEPARAMETERFVEXTPROC) wglxGetProcAddress("glGetColorTableParameterfvEXT");

	}

	if (GL_EXT_blend_color_supported = isExtensionSupported("GL_EXT_blend_color")){
		glBlendColorEXT = (PFNGLBLENDCOLOREXTPROC) wglxGetProcAddress("glBlendColorEXT");
	}

	if (GL_EXT_blend_minmax_supported = isExtensionSupported("GL_EXT_blend_minmax")){
		glBlendEquationEXT = (PFNGLBLENDEQUATIONEXTPROC) wglxGetProcAddress("glBlendEquationEXT");
	}

}
