/*
 * 05/28/2003
 *
 * error.h
 * Fonctions permettant de logger les erreurs 
 *
 * Author: Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _ERROR_H
#define _ERROR_H

#include "../globals.h"
#include <cstdarg>
#include <cstdio>
#include <cstdlib>

// ===============================
// Initialise le fichier d'erreurs
// ===============================
bool initErrorLog(void);

// ==========================
// Ferme le fichier d'erreurs
// ==========================
void closeErrorLog(void);

// ==============================================================
// Ajoute une ligne au fichier d'erreur
// Cette fonction utilise le meme format que la fonction printf()
// ==============================================================
int log(char *szFormat, ...);	


#endif

